#ifndef PERF08_DB_H
#define PERF08_DB_H
/*lint ++flb */

/* Raima Database Manager 12.0.0.1000 */

/*
 * Raima Database Manager
 *
 * Copyright (c) 2012 Raima Inc.,  All rights reserved.
 *
 * EXAMPLE - perf08
 *
 * This is the DDL (Database Definition Language) for a simple Bill of 
 * Materials database.  This version uses relation style idexes for 
 * relationships instead of sets.
 */


/* database perf08_db record/key structure declarations */

struct ritem {
   char rid_code[16];
   char rdescription[58];
   double rcost;
   int32_t rcomponent_count;
};

struct rbill {
   char rparent[16];
   char rcomponent[16];
   int32_t rsequence;
   double rquantity;
   int32_t rlevel;
};

struct rbom {
   char rparent[16];
   int32_t rsequence;
};

/* record, field and set table entry definitions */

/* File Id Constants */

/* Record Name Constants */
#define RITEM 10000
#define RBILL 10001

/* Field Name Constants */
#define RID_CODE 0L
#define RDESCRIPTION 1L
#define RCOST 2L
#define RCOMPONENT_COUNT 3L
#define RPARENT 1000L
#define RCOMPONENT 1001L
#define RSEQUENCE 1002L
#define RQUANTITY 1003L
#define RLEVEL 1004L
#define RBOM 1005L

/* Set Name Constants */

/* Field Sizes */
#define SIZEOF_RID_CODE 16
#define SIZEOF_RDESCRIPTION 58
#define SIZEOF_RCOST 8
#define SIZEOF_RCOMPONENT_COUNT 4
#define SIZEOF_RPARENT 16
#define SIZEOF_RCOMPONENT 16
#define SIZEOF_RSEQUENCE 4
#define SIZEOF_RQUANTITY 8
#define SIZEOF_RLEVEL 4

/*lint --flb */
#endif    /* PERF08_DB_H */
